//+------------------------------------------------------------------+
//|                                                 UmnickTrader.mq4 |
//|                               2009 Umnick. All rights reserved. |
//|                                            http://www.umnick.com |
//+------------------------------------------------------------------+
#property copyright " 2009 Umnick. All rights reserved."
#property link      "http://www.umnick.com"

//---- input parameters
extern double       StopBase=0.0050;

extern bool marketOrderOn = false;                //      
extern double spred = 0.0005;                     //  
extern int slippage = 200;                        //   
extern double absAmount = 0.01;                    //   
extern int timeframe = 240;                       // 
extern string currentIdOrder = "1";               //    

extern bool   martin      = false; 
extern double k           = 1.5;     // .  
extern int    n_lose      = 2;     //         
extern int    n_profit    = 3;     //         
extern double startAmount = 0.01;  //   

#define SIZE_BUF 8
//      
int currentBuySell = 1;
double pricePrev = 0;

bool isOpenPosition = false;                      // = true,     
int orderTicket = 0;                              //   
int orderTicket1 = 0;                             //  1- 
double openPrice = 0;                             //    

double arrayProfit[SIZE_BUF];
double arrayLoss[SIZE_BUF];
int currentIndex = 0;
double drawDown = 0;
double maxProfit = 0;
bool isSaveTester = false;                      // = true,     
double limit = 0;
double stop = 0;

int m=0;
int m1=0;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
 int i;
 
 for( i=0; i<SIZE_BUF; i++ ) {
  arrayProfit[i] = StopBase;
  arrayLoss[i] = StopBase;
 }
 return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
 return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+

int start()
{
 string action = "";
 double sumProfit = 0., sumLoss = 0.;
 int i;
 
 if( IsTradeAllowed() == false )
  return;
 if( limit == 0. )
  limit = StopBase;
 if( stop == 0. )
  stop = StopBase;

 CalcDrawDown( currentIdOrder );
 
 if( NextBar() == true ) {
  //       
  if( GetCountOpenOrders( currentIdOrder ) == 0 ) {
   //    -    
   
   int resultTransaction = GetResultTransaction();
   if( isOpenPosition == true ) {
    //    - 
    isOpenPosition = false;
    if( resultTransaction > 0 ) {
     //   
     arrayProfit[currentIndex] = maxProfit;
     arrayLoss[currentIndex] = StopBase;
     
   //**********************  
     m=0;
     if(martin)
       {
         if(m1<n_profit)
           {
             absAmount=absAmount*k;
             m1++;
           }
              
         if(m1 == n_profit)
           {
             absAmount=startAmount;
             m1=0;
           }
       }
       else
       {
         absAmount = startAmount;
       }
     //******************************
     
    }
    else
    if( resultTransaction < 0 ) {
     //   
     arrayProfit[currentIndex] = StopBase;
     arrayLoss[currentIndex] = drawDown;
     //   
     currentBuySell = -currentBuySell;
     
     //*******  ******
     m1=0;
     if(martin)
       {
         if(m<n_lose)
           {
             absAmount=absAmount*k;
             m++;
           }
               
         if(m == n_lose)
           {
             absAmount=startAmount;
             m=0;
           }
       }
     else
       {
         absAmount = startAmount;       
       }  
      //************************* 
     
    }
    if( currentIndex+1 < SIZE_BUF )
     currentIndex = currentIndex+1;
    else
     currentIndex = 0;
   }
   //    
   sumProfit = 0.;
   sumLoss = 0.;
   for( i=0; i<SIZE_BUF; i++ ) {
    sumProfit = sumProfit+arrayProfit[i];
    sumLoss = sumLoss+arrayLoss[i];
   }
   if( sumProfit > StopBase/2 )
    limit = sumProfit/SIZE_BUF;
   if( sumLoss > StopBase/2 )
    stop = sumLoss/SIZE_BUF;
   //   
   if( currentBuySell == 1 )
    action = "Buy";
   else
    action = "Sell";
   limit = MathMax(spred*2,limit);
   ActionPosition( action, currentIdOrder, absAmount, limit, stop );
   if( GetCountOpenOrders( currentIdOrder ) > 0 ) {
    //  
    orderTicket1 = orderTicket;
    isOpenPosition = true;
    maxProfit = 0;
    drawDown = 0;
   }
  }
 }
 else {
  if( IsOptimization() == false && IsTesting() == false && isSaveTester == true && isOpenPosition == true ) {
   if( GetCountOpenOrders( currentIdOrder ) == 0 ) {
    //      ,     
    //        
    RefreshRates();
    if( currentBuySell == 1 ) {
     action = "Buy";
     limit = MathMax(spred*2,limit-(Ask-openPrice));
     stop = stop+(Ask-openPrice);
    }
    else {
     action = "Sell";
     limit = MathMax(spred*2,limit+(Bid-openPrice));
     stop = stop-(Bid-openPrice);
    }
    ActionPosition( action, currentIdOrder, absAmount, limit, stop );
    if( GetCountOpenOrders( currentIdOrder ) > 0 ) {
     //  
     orderTicket1 = orderTicket;
     isOpenPosition = true;
     maxProfit = 0;
     drawDown = 0;
    }
   }
  }
 }
 return(0);
}
//+------------------------------------------------------------------+


bool NextBar()
{
 bool rt = false;
 double price = (iOpen( NULL, timeframe, 1 )+iHigh( NULL, timeframe, 1 )+iLow( NULL, timeframe, 1 )+iClose( NULL, timeframe, 1 ))/4;
 if( MathAbs(price-pricePrev) >= StopBase ) {
  pricePrev = price;
  rt = true;
  if( IsOptimization() == false && IsTesting() == false )
   Print("NextBar ", price);
 }
 return(rt);
}

int GetCountOpenOrders( string idSignal )
{
 int j, count;
 
 count = 0;
 for( j=0; j<OrdersTotal(); j++) {
  if( OrderSelect( j, SELECT_BY_POS, MODE_TRADES ) ) {
   if( Symbol() == OrderSymbol() && idSignal == OrderComment()  ) {
    count = count+1;
   }
  }
 }
 return(count);
}

double GetResultTransaction()
// > 0 -    
// < 0 -    
{
 int res = 0;

 if( OrderSelect( orderTicket1, SELECT_BY_TICKET, MODE_HISTORY ) ) {
  res = OrderProfit();
  Print("ResTran ", orderTicket1, " ", res);
 }
 return(res);
}

void CalcDrawDown( string idSignal )
{
 int j, order, typeOrder;
 
 for( j=0; j<OrdersTotal(); j++) {
  if( OrderSelect( j, SELECT_BY_POS, MODE_TRADES ) ) {
   if( Symbol() == OrderSymbol() && idSignal == OrderComment()  ) {
    typeOrder = OrderType();
    openPrice = OrderOpenPrice();
    if( typeOrder == OP_BUY ) {
     RefreshRates();
     if( maxProfit < High[0]-openPrice )
      maxProfit = High[0]-openPrice;
     if( drawDown < openPrice-Low[0] )
      drawDown = openPrice-Low[0];
    }
    if( typeOrder == OP_SELL ) {
     RefreshRates();
     if( maxProfit < openPrice-Low[0] )
      maxProfit = openPrice-Low[0];
     if( drawDown < High[0]-openPrice )
      drawDown = High[0]-openPrice;
    }       
   }
  }
 }
}

void ActionPosition( string action, string idSignal, double amount, double limit, double stop )
{
 int i, j, typeOrder;
 double price = 0., nAsk = 0., nBid = 0.;
 
 if( action == "Buy" ) {
  // 
  for( i=0; i<7; i++ ) {
   if( IsTradeAllowed() ) {
    RefreshRates();
    nAsk = Ask;
    if( IsOptimization() || IsTesting() )
     nAsk = NormalizeDouble(nAsk, MarketInfo(Symbol(), MODE_DIGITS));
    if( marketOrderOn == false )
     orderTicket = OrderSend( Symbol(), OP_BUY, amount, nAsk, slippage, NormalizeDouble(nAsk-stop, MarketInfo(Symbol(), MODE_DIGITS)), NormalizeDouble(nAsk+limit, MarketInfo(Symbol(), MODE_DIGITS)), idSignal, 0, 0, CLR_NONE );
    else {
     //    
     orderTicket = OrderSend( Symbol(), OP_BUY, amount, nAsk, slippage, 0, 0, idSignal, 0, 0, CLR_NONE );
     if( orderTicket > 0 ) {
      OrderSelect( orderTicket, SELECT_BY_TICKET );
      OrderModify( orderTicket, OrderOpenPrice(), NormalizeDouble(nAsk-stop, MarketInfo(Symbol(), MODE_DIGITS)), NormalizeDouble(nAsk+limit, MarketInfo(Symbol(), MODE_DIGITS)), 0, CLR_NONE );
     }
    }
    if( orderTicket <= 0 )
     Print(": ",GetLastError());  
    else {
     Print( " "+Symbol()+" id="+idSignal+" stop="+stop+" limit="+limit+" amount="+amount );
     PlaySound("ok.wav");
     return( 0 );
    }
   }       
   Sleep( 10000 );
  }   
  Print( "   "+Symbol()+" id="+idSignal+" stop="+stop+" limit="+limit );
  PlaySound( "disconnect.wav" );
 }
 else
 if( action == "Sell" ) {
  // 
  for( i=0; i<7; i++ ) {
   if( IsTradeAllowed() ) {
    RefreshRates();
    nBid = Bid;
    if( IsOptimization() || IsTesting() )
     nBid = NormalizeDouble(nBid, MarketInfo(Symbol(), MODE_DIGITS));
    if( marketOrderOn == false )
     orderTicket = OrderSend( Symbol(), OP_SELL, amount, nBid, slippage, NormalizeDouble(nBid+stop, MarketInfo(Symbol(), MODE_DIGITS)), NormalizeDouble(nBid-limit, MarketInfo(Symbol(), MODE_DIGITS)), idSignal, 0, 0, CLR_NONE );
    else {
     //    
     orderTicket = OrderSend( Symbol(), OP_SELL, amount, nBid, slippage, 0, 0, idSignal, 0, 0, CLR_NONE );
     if( orderTicket > 0 ) {
      OrderSelect( orderTicket, SELECT_BY_TICKET );
      OrderModify( orderTicket, OrderOpenPrice(), NormalizeDouble(nBid+stop, MarketInfo(Symbol(), MODE_DIGITS)), NormalizeDouble(nBid-limit, MarketInfo(Symbol(), MODE_DIGITS)), 0, CLR_NONE );
     }
    }
    if( orderTicket <= 0 )
     Print(": ",GetLastError());  
    else {
     Print( " "+Symbol()+" id="+idSignal+" stop="+stop+" limit="+limit+" amount="+amount );
     PlaySound("ok.wav");
     return( 0 );
    }
   }       
   Sleep( 10000 );
  }   
  Print( "   "+Symbol()+" id="+idSignal+" stop="+stop+" limit="+limit );
  PlaySound( "disconnect.wav" );
 }
}